<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des zones d'hébergement n'ont pas pu être chargées."
    />
    <template v-else-if="accommodationZoneCounts">
      <h2 class="fr-h5">Zones d'hébergement</h2>
      <StatsList
        v-if="accommodationZoneCounts.length"
        :total-count="beneficiaryCount"
        :stats="accommodationZoneCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des zones
        d'hébergement.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { ACCOMMODATION_ZONE_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: accommodationZoneCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('accommodationZoneCounts', loadAccommodationZoneCounts, {
    server: false
  })

  watch(() => props.filters, refresh)

  async function loadAccommodationZoneCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'accommodation_zone',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const accommodationZoneResCounts = res.data.data.map(
        accommodationZone => ({
          key: accommodationZone.accommodation_zone,
          label: labelOrUnprovided(
            accommodationZone.accommodation_zone,
            ACCOMMODATION_ZONE_OPTIONS
          ),
          count: parseInt(accommodationZone.countDistinct.id)
        })
      )
      accommodationZoneResCounts.sort((a, b) => b.count - a.count)
      return accommodationZoneResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
